<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::Exception Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1Exception.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1Exception-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::Exception Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class for basic exception functionality.  
 <a href="classOpenSim_1_1Exception.html#details">More...</a></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::Exception:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1Exception.png" usemap="#OpenSim::Exception_map" alt=""/>
  <map id="OpenSim::Exception_map" name="OpenSim::Exception_map">
<area href="classOpenSim_1_1ComponentAlreadyPartOfOwnershipTree.html" alt="OpenSim::ComponentAlreadyPartOfOwnershipTree" shape="rect" coords="311,112,612,136"/>
<area href="classOpenSim_1_1ComponentHasNoName.html" title="Component Exceptions." alt="OpenSim::ComponentHasNoName" shape="rect" coords="311,168,612,192"/>
<area href="classOpenSim_1_1ComponentHasNoSystem.html" alt="OpenSim::ComponentHasNoSystem" shape="rect" coords="311,224,612,248"/>
<area href="classOpenSim_1_1ComponentIsAnOrphan.html" alt="OpenSim::ComponentIsAnOrphan" shape="rect" coords="311,280,612,304"/>
<area href="classOpenSim_1_1ComponentIsRootWithNoSubcomponents.html" alt="OpenSim::ComponentIsRootWithNoSubcomponents" shape="rect" coords="311,336,612,360"/>
<area href="classOpenSim_1_1ComponentNotFound.html" alt="OpenSim::ComponentNotFound" shape="rect" coords="311,392,612,416"/>
<area href="classOpenSim_1_1ConnecteeNotSpecified.html" alt="OpenSim::ConnecteeNotSpecified" shape="rect" coords="311,448,612,472"/>
<area href="classOpenSim_1_1DataAdapterAlreadyRegistered.html" alt="OpenSim::DataAdapterAlreadyRegistered" shape="rect" coords="311,504,612,528"/>
<area href="classOpenSim_1_1DataTypeMismatch.html" alt="OpenSim::DataTypeMismatch" shape="rect" coords="311,560,612,584"/>
<area href="classOpenSim_1_1EmptyTable.html" alt="OpenSim::EmptyTable" shape="rect" coords="311,616,612,640"/>
<area href="classOpenSim_1_1FileDeletionThrowerException.html" title="Thrown by FileDeletionThrower::throwIfDeleted()." alt="OpenSim::FileDeletionThrowerException" shape="rect" coords="311,672,612,696"/>
<area href="classOpenSim_1_1IOError.html" alt="OpenSim::IOError" shape="rect" coords="311,728,612,752"/>
<area href="classOpenSim_1_1IncorrectMetaDataLength.html" alt="OpenSim::IncorrectMetaDataLength" shape="rect" coords="311,784,612,808"/>
<area href="classOpenSim_1_1IncorrectNumTokens.html" alt="OpenSim::IncorrectNumTokens" shape="rect" coords="311,840,612,864"/>
<area href="classOpenSim_1_1IndexOutOfRange.html" alt="OpenSim::IndexOutOfRange" shape="rect" coords="311,896,612,920"/>
<area href="classOpenSim_1_1InputNotConnected.html" title="ComponentSocket Exceptions." alt="OpenSim::InputNotConnected" shape="rect" coords="311,952,612,976"/>
<area href="classOpenSim_1_1InputNotFound.html" alt="OpenSim::InputNotFound" shape="rect" coords="311,1008,612,1032"/>
<area href="classOpenSim_1_1InvalidArgument.html" alt="OpenSim::InvalidArgument" shape="rect" coords="311,1064,612,1088"/>
<area href="classOpenSim_1_1InvalidCall.html" alt="OpenSim::InvalidCall" shape="rect" coords="311,1120,612,1144"/>
<area href="classOpenSim_1_1InvalidColumn.html" alt="OpenSim::InvalidColumn" shape="rect" coords="311,1176,612,1200"/>
<area href="classOpenSim_1_1InvalidColumnLabel.html" alt="OpenSim::InvalidColumnLabel" shape="rect" coords="311,1232,612,1256"/>
<area href="classOpenSim_1_1InvalidComponentName.html" alt="OpenSim::InvalidComponentName" shape="rect" coords="311,1288,612,1312"/>
<area href="classOpenSim_1_1InvalidPropertyValue.html" title="Property Exceptions." alt="OpenSim::InvalidPropertyValue" shape="rect" coords="311,1344,612,1368"/>
<area href="classOpenSim_1_1InvalidRow.html" alt="OpenSim::InvalidRow" shape="rect" coords="311,1400,612,1424"/>
<area href="classOpenSim_1_1InvalidTable.html" alt="OpenSim::InvalidTable" shape="rect" coords="311,1456,612,1480"/>
<area href="classOpenSim_1_1InvalidTemplateArgument.html" alt="OpenSim::InvalidTemplateArgument" shape="rect" coords="311,1512,612,1536"/>
<area href="classOpenSim_1_1InvalidTimeRange.html" alt="OpenSim::InvalidTimeRange" shape="rect" coords="311,1568,612,1592"/>
<area href="classOpenSim_1_1JointFramesAreTheSame.html" alt="OpenSim::JointFramesAreTheSame" shape="rect" coords="311,1624,612,1648"/>
<area href="classOpenSim_1_1JointFramesHaveSameBaseFrame.html" alt="OpenSim::JointFramesHaveSameBaseFrame" shape="rect" coords="311,1680,612,1704"/>
<area href="classOpenSim_1_1JointHasNoCoordinates.html" alt="OpenSim::JointHasNoCoordinates" shape="rect" coords="311,1736,612,1760"/>
<area href="classOpenSim_1_1KeyExists.html" alt="OpenSim::KeyExists" shape="rect" coords="311,1792,612,1816"/>
<area href="classOpenSim_1_1KeyNotFound.html" alt="OpenSim::KeyNotFound" shape="rect" coords="311,1848,612,1872"/>
<area href="classOpenSim_1_1MissingMetaData.html" alt="OpenSim::MissingMetaData" shape="rect" coords="311,1904,612,1928"/>
<area href="classOpenSim_1_1MocoCasADiSolverNotAvailable.html" alt="OpenSim::MocoCasADiSolverNotAvailable" shape="rect" coords="311,1960,612,1984"/>
<area href="classOpenSim_1_1MocoTrajectoryIsSealed.html" title="This exception is thrown if you try to invoke most methods on MocoTrajectory while the trajectory is ..." alt="OpenSim::MocoTrajectoryIsSealed" shape="rect" coords="311,2016,612,2040"/>
<area href="classOpenSim_1_1MocoTropterSolverNotAvailable.html" alt="OpenSim::MocoTropterSolverNotAvailable" shape="rect" coords="311,2072,612,2096"/>
<area href="classOpenSim_1_1ModelHasNoSystem.html" title="Model Exceptions." alt="OpenSim::ModelHasNoSystem" shape="rect" coords="311,2128,612,2152"/>
<area href="classOpenSim_1_1MuscleCannotEquilibrate.html" alt="OpenSim::MuscleCannotEquilibrate" shape="rect" coords="311,2184,612,2208"/>
<area href="classOpenSim_1_1NoColumnLabels.html" alt="OpenSim::NoColumnLabels" shape="rect" coords="311,2240,612,2264"/>
<area href="classOpenSim_1_1NoRegisteredDataAdapter.html" alt="OpenSim::NoRegisteredDataAdapter" shape="rect" coords="311,2296,612,2320"/>
<area href="classOpenSim_1_1NonUniqueLabels.html" alt="OpenSim::NonUniqueLabels" shape="rect" coords="311,2352,612,2376"/>
<area href="classOpenSim_1_1OutputNotFound.html" alt="OpenSim::OutputNotFound" shape="rect" coords="311,2408,612,2432"/>
<area href="classOpenSim_1_1PhysicalOffsetFramesFormLoop.html" alt="OpenSim::PhysicalOffsetFramesFormLoop" shape="rect" coords="311,2464,612,2488"/>
<area href="classOpenSim_1_1STODataTypeNotSupported.html" alt="OpenSim::STODataTypeNotSupported" shape="rect" coords="311,2520,612,2544"/>
<area href="classOpenSim_1_1SocketNotFound.html" alt="OpenSim::SocketNotFound" shape="rect" coords="311,2576,612,2600"/>
<area href="classOpenSim_1_1StatesTrajectory_1_1DataIsInDegrees.html" title="Thrown by createFromStatesStorage()." alt="OpenSim::StatesTrajectory::DataIsInDegrees" shape="rect" coords="311,2632,612,2656"/>
<area href="classOpenSim_1_1StatesTrajectory_1_1ExtraColumns.html" title="Thrown when trying to create a StatesTrajectory from states data, and the data contains columns that ..." alt="OpenSim::StatesTrajectory::ExtraColumns" shape="rect" coords="311,2688,612,2712"/>
<area href="classOpenSim_1_1StatesTrajectory_1_1IncompatibleModel.html" title="Thrown when trying to use a StatesTrajectory with an incompatible model." alt="OpenSim::StatesTrajectory::IncompatibleModel" shape="rect" coords="311,2744,612,2768"/>
<area href="classOpenSim_1_1StatesTrajectory_1_1InconsistentState.html" title="Thrown when trying to append a state that is not consistent with the rest of the trajectory." alt="OpenSim::StatesTrajectory::InconsistentState" shape="rect" coords="311,2800,612,2824"/>
<area href="classOpenSim_1_1StatesTrajectory_1_1MissingColumns.html" title="Thrown when trying to create a StatesTrajectory from states data, and the data does not contain a col..." alt="OpenSim::StatesTrajectory::MissingColumns" shape="rect" coords="311,2856,612,2880"/>
<area href="classOpenSim_1_1SubcomponentsWithDuplicateName.html" alt="OpenSim::SubcomponentsWithDuplicateName" shape="rect" coords="311,2912,612,2936"/>
<area href="classOpenSim_1_1TableMissingHeader.html" alt="OpenSim::TableMissingHeader" shape="rect" coords="311,2968,612,2992"/>
<area href="classOpenSim_1_1TableNotFoundException.html" alt="OpenSim::TableNotFoundException" shape="rect" coords="311,3024,612,3048"/>
<area href="classOpenSim_1_1TimeOutOfRange.html" alt="OpenSim::TimeOutOfRange" shape="rect" coords="311,3080,612,3104"/>
<area href="classOpenSim_1_1UnsupportedFileType.html" alt="OpenSim::UnsupportedFileType" shape="rect" coords="311,3136,612,3160"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a01d5cbb54d9c6d5ff56ece34d95aed8a"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#a01d5cbb54d9c6d5ff56ece34d95aed8a">Exception</a> (const std::string &amp;aMsg=&quot;&quot;, const std::string &amp;aFile=&quot;&quot;, int aLine=-1)</td></tr>
<tr class="memdesc:a01d5cbb54d9c6d5ff56ece34d95aed8a"><td class="mdescLeft">&#160;</td><td class="mdescRight">This constructor is for backward compatibility.  <a href="classOpenSim_1_1Exception.html#a01d5cbb54d9c6d5ff56ece34d95aed8a">More...</a><br /></td></tr>
<tr class="separator:a01d5cbb54d9c6d5ff56ece34d95aed8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85669282908c301b734b315c1cfa1bc8"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#a85669282908c301b734b315c1cfa1bc8">Exception</a> (const std::string &amp;file, size_t line, const std::string &amp;func)</td></tr>
<tr class="memdesc:a85669282908c301b734b315c1cfa1bc8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Call this constructor from derived classes to add file, line and function information to the error message.  <a href="classOpenSim_1_1Exception.html#a85669282908c301b734b315c1cfa1bc8">More...</a><br /></td></tr>
<tr class="separator:a85669282908c301b734b315c1cfa1bc8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afda39716e3190347a561f961a66cbcfc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#afda39716e3190347a561f961a66cbcfc">Exception</a> (const std::string &amp;file, size_t line, const std::string &amp;func, const std::string &amp;msg)</td></tr>
<tr class="memdesc:afda39716e3190347a561f961a66cbcfc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Use this when you want to throw an <a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a> (with OPENSIM_THROW or OPENSIM_THROW_IF) and also provide a message.  <a href="classOpenSim_1_1Exception.html#afda39716e3190347a561f961a66cbcfc">More...</a><br /></td></tr>
<tr class="separator:afda39716e3190347a561f961a66cbcfc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac2ae0242dd5f42844de5cdf70a82129a"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#ac2ae0242dd5f42844de5cdf70a82129a">Exception</a> (const std::string &amp;file, size_t line, const std::string &amp;func, const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;obj)</td></tr>
<tr class="memdesc:ac2ae0242dd5f42844de5cdf70a82129a"><td class="mdescLeft">&#160;</td><td class="mdescRight">The message created by this constructor will contain the class name and instance name of the provided <a class="el" href="classOpenSim_1_1Object.html" title="This is the base class for all OpenSim objects that are serializable (meaning they can be written to ...">Object</a>.  <a href="classOpenSim_1_1Exception.html#ac2ae0242dd5f42844de5cdf70a82129a">More...</a><br /></td></tr>
<tr class="separator:ac2ae0242dd5f42844de5cdf70a82129a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac706e5c71f298482a54b6e663b344aeb"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#ac706e5c71f298482a54b6e663b344aeb">Exception</a> (const std::string &amp;file, size_t line, const std::string &amp;func, const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;obj, const std::string &amp;msg)</td></tr>
<tr class="memdesc:ac706e5c71f298482a54b6e663b344aeb"><td class="mdescLeft">&#160;</td><td class="mdescRight">The message created by this constructor will contain the class name and instance name of the provided <a class="el" href="classOpenSim_1_1Object.html" title="This is the base class for all OpenSim objects that are serializable (meaning they can be written to ...">Object</a>, and also accepts a message.  <a href="classOpenSim_1_1Exception.html#ac706e5c71f298482a54b6e663b344aeb">More...</a><br /></td></tr>
<tr class="separator:ac706e5c71f298482a54b6e663b344aeb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a65f8c04d93f21dd8077f64fc806959"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:a8a65f8c04d93f21dd8077f64fc806959"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#a8a65f8c04d93f21dd8077f64fc806959">Exception</a> (const std::string &amp;file, size_t line, const std::string &amp;func, spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="memdesc:a8a65f8c04d93f21dd8077f64fc806959"><td class="mdescLeft">&#160;</td><td class="mdescRight">Use this when you want to throw an <a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a> (with OPENSIM_THROW or OPENSIM_THROW_IF) and also provide a message that is formatted using fmt::format() syntax.  <a href="classOpenSim_1_1Exception.html#a8a65f8c04d93f21dd8077f64fc806959">More...</a><br /></td></tr>
<tr class="separator:a8a65f8c04d93f21dd8077f64fc806959"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbf258f41c566be4af93c2dabf7783c4"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:abbf258f41c566be4af93c2dabf7783c4"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#abbf258f41c566be4af93c2dabf7783c4">Exception</a> (const std::string &amp;file, size_t line, const std::string &amp;func, const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;obj, spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="memdesc:abbf258f41c566be4af93c2dabf7783c4"><td class="mdescLeft">&#160;</td><td class="mdescRight">The message created by this constructor will contain the class name and instance name of the provided <a class="el" href="classOpenSim_1_1Object.html" title="This is the base class for all OpenSim objects that are serializable (meaning they can be written to ...">Object</a>, and also accepts a message formatted using fmt::format() syntax.  <a href="classOpenSim_1_1Exception.html#abbf258f41c566be4af93c2dabf7783c4">More...</a><br /></td></tr>
<tr class="separator:abbf258f41c566be4af93c2dabf7783c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae5ad1d4c237320313cdfa5f4dc44fa53"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#ae5ad1d4c237320313cdfa5f4dc44fa53">~Exception</a> ()  throw ()</td></tr>
<tr class="separator:ae5ad1d4c237320313cdfa5f4dc44fa53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a95f5578dc48c56f828986c346f13a8e0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#a95f5578dc48c56f828986c346f13a8e0">setMessage</a> (const std::string &amp;aMsg)</td></tr>
<tr class="separator:a95f5578dc48c56f828986c346f13a8e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae3a719b15a4f522207847a720e2af7b1"><td class="memItemLeft" align="right" valign="top">const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#ae3a719b15a4f522207847a720e2af7b1">getMessage</a> () const</td></tr>
<tr class="separator:ae3a719b15a4f522207847a720e2af7b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abe7156536aa1a7205ed74660ca72e7f5"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#abe7156536aa1a7205ed74660ca72e7f5">print</a> (std::ostream &amp;aOut) const</td></tr>
<tr class="separator:abe7156536aa1a7205ed74660ca72e7f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab82fe5f267ae6474eec07f805b9192ca"><td class="memItemLeft" align="right" valign="top">const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#ab82fe5f267ae6474eec07f805b9192ca">what</a> () const noexcept override</td></tr>
<tr class="separator:ab82fe5f267ae6474eec07f805b9192ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:af68b64dbb1b59868e7ccb7ab9782d35d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#af68b64dbb1b59868e7ccb7ab9782d35d">addMessage</a> (const std::string &amp;msg)</td></tr>
<tr class="memdesc:af68b64dbb1b59868e7ccb7ab9782d35d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add to the error message that will be returned for the exception.  <a href="classOpenSim_1_1Exception.html#af68b64dbb1b59868e7ccb7ab9782d35d">More...</a><br /></td></tr>
<tr class="separator:af68b64dbb1b59868e7ccb7ab9782d35d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="related"></a>
Related Functions</h2></td></tr>
<tr><td class="ititle" colspan="2"><p>(Note that these are not member functions.) </p>
</td></tr>
<tr><td colspan="2"><div class="groupHeader">Macros to throw OpenSim exceptions</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p>The purpose of these macros is to aid with consistent message formatting, include file/line/function information in all messages, and to make it easier for developers to produce good messages.</p>
<p><br  />
 </p>
</div></td></tr>
<tr class="memitem:a22b9c2ec3cb629075f2d96a6669cdbc9"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#a22b9c2ec3cb629075f2d96a6669cdbc9">OPENSIM_THROW</a>(EXCEPTION, ...)&#160;&#160;&#160;    throw EXCEPTION{__FILE__, __LINE__, __func__, __VA_ARGS__};</td></tr>
<tr class="memdesc:a22b9c2ec3cb629075f2d96a6669cdbc9"><td class="mdescLeft">&#160;</td><td class="mdescRight"><br  />
  <a href="classOpenSim_1_1Exception.html#a22b9c2ec3cb629075f2d96a6669cdbc9">More...</a><br /></td></tr>
<tr class="separator:a22b9c2ec3cb629075f2d96a6669cdbc9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae16eef2046486e4847244130a27ec6b8"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Exception.html#ae16eef2046486e4847244130a27ec6b8">OPENSIM_THROW_IF</a>(CONDITION,  EXCEPTION, ...)</td></tr>
<tr class="memdesc:ae16eef2046486e4847244130a27ec6b8"><td class="mdescLeft">&#160;</td><td class="mdescRight">This macro checks the given condition and throws the given exception if the condition is true.  <a href="classOpenSim_1_1Exception.html#ae16eef2046486e4847244130a27ec6b8">More...</a><br /></td></tr>
<tr class="separator:ae16eef2046486e4847244130a27ec6b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>A class for basic exception functionality. </p>
<p>To create exception classes in <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a>, use the following guidelines. If the intention is to derive from an exception named, for example, BaseException that is part of <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a>, use the following blueprint: </p><div class="fragment"><div class="line"><span class="keyword">class </span>MyNewException : <span class="keyword">public</span> BaseException {</div>
<div class="line"><span class="keyword">public</span>:</div>
<div class="line">    MyNewException(<span class="keyword">const</span> std::string&amp; file,</div>
<div class="line">                   <span class="keywordtype">size_t</span> line,</div>
<div class="line">                   <span class="keyword">const</span> std::string&amp; func,</div>
<div class="line">                   &lt;more parameters as appropriate&gt;) :</div>
<div class="line">    BaseException(file, line, func) {</div>
<div class="line">        std::string message = &lt;create the desired message&gt;;</div>
<div class="line">        <a class="code" href="classOpenSim_1_1Exception.html#af68b64dbb1b59868e7ccb7ab9782d35d">addMessage</a>(message);</div>
<div class="line">    }</div>
<div class="line">};</div>
<div class="ttc" id="aclassOpenSim_1_1Exception_html_af68b64dbb1b59868e7ccb7ab9782d35d"><div class="ttname"><a href="classOpenSim_1_1Exception.html#af68b64dbb1b59868e7ccb7ab9782d35d">OpenSim::Exception::addMessage</a></div><div class="ttdeci">void addMessage(const std::string &amp;msg)</div><div class="ttdoc">Add to the error message that will be returned for the exception.</div></div>
</div><!-- fragment --><p> <a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a> class manages the concatenation of error messages from all the derived classes. When creating new exceptions, remember to call <a class="el" href="classOpenSim_1_1Exception.html#af68b64dbb1b59868e7ccb7ab9782d35d" title="Add to the error message that will be returned for the exception.">addMessage()</a> as shown above if the exception class does have any error message. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a01d5cbb54d9c6d5ff56ece34d95aed8a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a01d5cbb54d9c6d5ff56ece34d95aed8a">&#9670;&nbsp;</a></span>Exception() <span class="overload">[1/7]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Exception::Exception </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>aMsg</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>aFile</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aLine</em> = <code>-1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This constructor is for backward compatibility. </p>
<p>Use the constructor taking file, line, func. <br  />
 </p>

</div>
</div>
<a id="a85669282908c301b734b315c1cfa1bc8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a85669282908c301b734b315c1cfa1bc8">&#9670;&nbsp;</a></span>Exception() <span class="overload">[2/7]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Exception::Exception </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Call this constructor from derived classes to add file, line and function information to the error message. </p>
<p>Use this when throwing Derived classes. Use OPENSIM_THROW_&lt;&gt; macros at throw sites. <br  />
 </p>

</div>
</div>
<a id="afda39716e3190347a561f961a66cbcfc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afda39716e3190347a561f961a66cbcfc">&#9670;&nbsp;</a></span>Exception() <span class="overload">[3/7]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Exception::Exception </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>msg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Use this when you want to throw an <a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a> (with OPENSIM_THROW or OPENSIM_THROW_IF) and also provide a message. </p>
<p><br  />
 </p>

</div>
</div>
<a id="ac2ae0242dd5f42844de5cdf70a82129a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac2ae0242dd5f42844de5cdf70a82129a">&#9670;&nbsp;</a></span>Exception() <span class="overload">[4/7]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Exception::Exception </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;&#160;</td>
          <td class="paramname"><em>obj</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The message created by this constructor will contain the class name and instance name of the provided <a class="el" href="classOpenSim_1_1Object.html" title="This is the base class for all OpenSim objects that are serializable (meaning they can be written to ...">Object</a>. </p>
<p>Use this when throwing derived classes. Use OPENSIM_THROW_&lt;&gt; macros at throw sites. <br  />
 </p>

</div>
</div>
<a id="ac706e5c71f298482a54b6e663b344aeb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac706e5c71f298482a54b6e663b344aeb">&#9670;&nbsp;</a></span>Exception() <span class="overload">[5/7]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Exception::Exception </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;&#160;</td>
          <td class="paramname"><em>obj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>msg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The message created by this constructor will contain the class name and instance name of the provided <a class="el" href="classOpenSim_1_1Object.html" title="This is the base class for all OpenSim objects that are serializable (meaning they can be written to ...">Object</a>, and also accepts a message. </p>
<p>Use this when throwing <a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a> directly. Use OPENSIM_THROW_&lt;&gt; macros at throw sites. <br  />
 </p>

</div>
</div>
<a id="a8a65f8c04d93f21dd8077f64fc806959"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8a65f8c04d93f21dd8077f64fc806959">&#9670;&nbsp;</a></span>Exception() <span class="overload">[6/7]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Exception::Exception </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Use this when you want to throw an <a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a> (with OPENSIM_THROW or OPENSIM_THROW_IF) and also provide a message that is formatted using fmt::format() syntax. </p>

</div>
</div>
<a id="abbf258f41c566be4af93c2dabf7783c4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abbf258f41c566be4af93c2dabf7783c4">&#9670;&nbsp;</a></span>Exception() <span class="overload">[7/7]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Exception::Exception </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;&#160;</td>
          <td class="paramname"><em>obj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The message created by this constructor will contain the class name and instance name of the provided <a class="el" href="classOpenSim_1_1Object.html" title="This is the base class for all OpenSim objects that are serializable (meaning they can be written to ...">Object</a>, and also accepts a message formatted using fmt::format() syntax. </p>
<p>Use this when throwing an <a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a> directly. Use OPENSIM_THROW_FRMOBJ and OPENSIM_THROW_IF_FRMOBJ macros at throw sites. </p>

</div>
</div>
<a id="ae5ad1d4c237320313cdfa5f4dc44fa53"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae5ad1d4c237320313cdfa5f4dc44fa53">&#9670;&nbsp;</a></span>~Exception()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual OpenSim::Exception::~Exception </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
        <tr>
          <td align="right">throw </td><td>(</td><td colspan="2"></td>
        </tr>
        <tr>
          <td align="right"></td><td>)</td><td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="af68b64dbb1b59868e7ccb7ab9782d35d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af68b64dbb1b59868e7ccb7ab9782d35d">&#9670;&nbsp;</a></span>addMessage()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::Exception::addMessage </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>msg</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Add to the error message that will be returned for the exception. </p>
<p><br  />
 </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1ComponentAlreadyPartOfOwnershipTree.html#a4e8b7b6ad20c7f8a989dcbe1fe2c8421">OpenSim::ComponentAlreadyPartOfOwnershipTree::ComponentAlreadyPartOfOwnershipTree()</a>, <a class="el" href="classOpenSim_1_1ComponentHasNoName.html#ac7fc2c70d28a8fc0835f39517331cfae">OpenSim::ComponentHasNoName::ComponentHasNoName()</a>, <a class="el" href="classOpenSim_1_1ComponentHasNoSystem.html#ac94c981a22617bdf6772b56589767bc5">OpenSim::ComponentHasNoSystem::ComponentHasNoSystem()</a>, <a class="el" href="classOpenSim_1_1ComponentIsAnOrphan.html#a9c8d1f7f82787f557c0f85ef88977313">OpenSim::ComponentIsAnOrphan::ComponentIsAnOrphan()</a>, <a class="el" href="classOpenSim_1_1ComponentIsRootWithNoSubcomponents.html#a3c9f210df3185cffdc3657fed5caf1fd">OpenSim::ComponentIsRootWithNoSubcomponents::ComponentIsRootWithNoSubcomponents()</a>, <a class="el" href="classOpenSim_1_1ComponentNotFoundOnSpecifiedPath.html#a0d972b0829d38d0902797961adaec87c">OpenSim::ComponentNotFoundOnSpecifiedPath::ComponentNotFoundOnSpecifiedPath()</a>, <a class="el" href="classOpenSim_1_1ConnecteeNotSpecified.html#adc971267449eb0984b712e8aad8b4418">OpenSim::ConnecteeNotSpecified::ConnecteeNotSpecified()</a>, <a class="el" href="classOpenSim_1_1DataAdapterAlreadyRegistered.html#ab259535b9b55b39802823429d8fcf73d">OpenSim::DataAdapterAlreadyRegistered::DataAdapterAlreadyRegistered()</a>, <a class="el" href="classOpenSim_1_1DataTypeMismatch.html#a4719e23c8a230e335dfeeb44f737ae5b">OpenSim::DataTypeMismatch::DataTypeMismatch()</a>, <a class="el" href="classOpenSim_1_1EmptyFileName.html#ac177fe561bf6696660039efda686f22a">OpenSim::EmptyFileName::EmptyFileName()</a>, <a class="el" href="classOpenSim_1_1EmptyTable.html#ad8b8730f81f0743138530a83c437238f">OpenSim::EmptyTable::EmptyTable()</a>, <a class="el" href="classOpenSim_1_1FileDeletionThrowerException.html#ac5b866b4c3c131184ed0bd3f29f65805">OpenSim::FileDeletionThrowerException::FileDeletionThrowerException()</a>, <a class="el" href="classOpenSim_1_1FileDoesNotExist.html#acfc107f90132f9763b35a801b5dc411a">OpenSim::FileDoesNotExist::FileDoesNotExist()</a>, <a class="el" href="classOpenSim_1_1FileExtensionNotFound.html#a34bcfe55b167e944ed8ff61b68a3c18a">OpenSim::FileExtensionNotFound::FileExtensionNotFound()</a>, <a class="el" href="classOpenSim_1_1FileIsEmpty.html#a864d5d7897110c2472d78756aba190f4">OpenSim::FileIsEmpty::FileIsEmpty()</a>, <a class="el" href="classOpenSim_1_1IncorrectMetaDataLength.html#a6bb950c15138041ad2171a7d520479e1">OpenSim::IncorrectMetaDataLength::IncorrectMetaDataLength()</a>, <a class="el" href="classOpenSim_1_1IncorrectNumColumnLabels.html#a434bb0a9fbff98aaf052143e79c06aeb">OpenSim::IncorrectNumColumnLabels::IncorrectNumColumnLabels()</a>, <a class="el" href="classOpenSim_1_1IncorrectNumColumns.html#a6dc37e2517eade51a2c61141de87e890">OpenSim::IncorrectNumColumns::IncorrectNumColumns()</a>, <a class="el" href="classOpenSim_1_1IncorrectNumMetaDataKeys.html#a223066bca74f1a44febdf50602f55881">OpenSim::IncorrectNumMetaDataKeys::IncorrectNumMetaDataKeys()</a>, <a class="el" href="classOpenSim_1_1IncorrectNumRows.html#a241140d8cf142bf0546395aa1ab67598">OpenSim::IncorrectNumRows::IncorrectNumRows()</a>, <a class="el" href="classOpenSim_1_1IncorrectNumTokens.html#a4a6a4a1611b61a720eac6e4365ff5139">OpenSim::IncorrectNumTokens::IncorrectNumTokens()</a>, <a class="el" href="classOpenSim_1_1IncorrectTableType.html#a6c232b7b264e1f371e2023f9f0f09498">OpenSim::IncorrectTableType::IncorrectTableType()</a>, <a class="el" href="classOpenSim_1_1InputNotConnected.html#a3f262c0573d3c67ed3181b5bb25aab67">OpenSim::InputNotConnected::InputNotConnected()</a>, <a class="el" href="classOpenSim_1_1InputNotFound.html#a425a05a6e8b2af77430aeb6916f136e1">OpenSim::InputNotFound::InputNotFound()</a>, <a class="el" href="classOpenSim_1_1InvalidComponentName.html#a01a1361f2f72f2e5a485edb7bae7c7db">OpenSim::InvalidComponentName::InvalidComponentName()</a>, <a class="el" href="classOpenSim_1_1InvalidPropertyValue.html#ad721cb42a75dd5d343ac8a641bb500ed">OpenSim::InvalidPropertyValue::InvalidPropertyValue()</a>, <a class="el" href="classOpenSim_1_1InvalidTimeRange.html#aedc2f69e83c4869afcbc93bc8537b18a">OpenSim::InvalidTimeRange::InvalidTimeRange()</a>, <a class="el" href="classOpenSim_1_1JointFramesAreTheSame.html#adac7852b8fd05d0150509b8b810e0f60">OpenSim::JointFramesAreTheSame::JointFramesAreTheSame()</a>, <a class="el" href="classOpenSim_1_1JointFramesHaveSameBaseFrame.html#a95b92f3f34b6d809de906532cf221505">OpenSim::JointFramesHaveSameBaseFrame::JointFramesHaveSameBaseFrame()</a>, <a class="el" href="classOpenSim_1_1JointHasNoCoordinates.html#a1d9300520d1db55f6f883ab0cbf45e5a">OpenSim::JointHasNoCoordinates::JointHasNoCoordinates()</a>, <a class="el" href="classOpenSim_1_1KeyExists.html#a481f59b1e54bf094f71b3d0f1083e213">OpenSim::KeyExists::KeyExists()</a>, <a class="el" href="classOpenSim_1_1KeyMissing.html#ab00c66554b917506df0bddef286e5cba">OpenSim::KeyMissing::KeyMissing()</a>, <a class="el" href="classOpenSim_1_1MetaDataLengthMismatch.html#a6e5e40dca7185b0d3a72232e0df6123d">OpenSim::MetaDataLengthMismatch::MetaDataLengthMismatch()</a>, <a class="el" href="classOpenSim_1_1MissingMetaData.html#aa585349104f098ea4608594e57b02239">OpenSim::MissingMetaData::MissingMetaData()</a>, <a class="el" href="classOpenSim_1_1MocoCasADiSolverNotAvailable.html#ac31fab09dbd4b578cd881c715e9775bc">OpenSim::MocoCasADiSolverNotAvailable::MocoCasADiSolverNotAvailable()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolverNotAvailable.html#a30e53c1829506d3e5b6c0835299194e3">OpenSim::MocoTropterSolverNotAvailable::MocoTropterSolverNotAvailable()</a>, <a class="el" href="classOpenSim_1_1ModelHasNoSystem.html#aaf3580850380c55b967af2c3e8531573">OpenSim::ModelHasNoSystem::ModelHasNoSystem()</a>, <a class="el" href="classOpenSim_1_1MuscleCannotEquilibrate.html#afc25e008e8dba2e0855254c1155de952">OpenSim::MuscleCannotEquilibrate::MuscleCannotEquilibrate()</a>, <a class="el" href="classOpenSim_1_1NoColumnLabels.html#a124ba994a691f22f28a16e038606ced4">OpenSim::NoColumnLabels::NoColumnLabels()</a>, <a class="el" href="classOpenSim_1_1NoRegisteredDataAdapter.html#a3c77de1e562833c3ded7ad31d512458d">OpenSim::NoRegisteredDataAdapter::NoRegisteredDataAdapter()</a>, <a class="el" href="classOpenSim_1_1NoTableFound.html#afdc60a1c863a6397eeb009195cdcb489">OpenSim::NoTableFound::NoTableFound()</a>, <a class="el" href="classOpenSim_1_1OutputNotFound.html#abb86de47f0e3ea3988a0bcb2ed7a0dba">OpenSim::OutputNotFound::OutputNotFound()</a>, <a class="el" href="classOpenSim_1_1PhysicalOffsetFramesFormLoop.html#a1bd3991c266dba2df940fc555f447228">OpenSim::PhysicalOffsetFramesFormLoop::PhysicalOffsetFramesFormLoop()</a>, <a class="el" href="classOpenSim_1_1RowLengthMismatch.html#a223c42c8b14393e64f67d68496d3c98e">OpenSim::RowLengthMismatch::RowLengthMismatch()</a>, <a class="el" href="classOpenSim_1_1SocketNotFound.html#a04d2de57e2608489eb24cf64b59ca52b">OpenSim::SocketNotFound::SocketNotFound()</a>, <a class="el" href="classOpenSim_1_1STODataTypeNotSupported.html#a1b19a0cbb5cc884fd67edc0b583bb6d8">OpenSim::STODataTypeNotSupported::STODataTypeNotSupported()</a>, <a class="el" href="classOpenSim_1_1SubcomponentsWithDuplicateName.html#a7cd458dc0a923a41c49ab0d23767bdc3">OpenSim::SubcomponentsWithDuplicateName::SubcomponentsWithDuplicateName()</a>, <a class="el" href="classOpenSim_1_1TableMissingHeader.html#a5b3dcb609f15e20422e09a771b41e8d9">OpenSim::TableMissingHeader::TableMissingHeader()</a>, <a class="el" href="classOpenSim_1_1TableNotFoundException.html#aa372ffee1783928459bd7d6473d45b91">OpenSim::TableNotFoundException::TableNotFoundException()</a>, <a class="el" href="classOpenSim_1_1TimeColumnNotIncreasing.html#a32ffd37e1e6e88cea778bb13003aea9f">OpenSim::TimeColumnNotIncreasing::TimeColumnNotIncreasing()</a>, <a class="el" href="classOpenSim_1_1TimeOutOfRange.html#a1f8a1acc0d893e9ed3f151d9c6f54c57">OpenSim::TimeOutOfRange::TimeOutOfRange()</a>, <a class="el" href="classOpenSim_1_1TimestampGreaterThanEqualToNext.html#a7f5182ad7418e37db5047793a2986dc6">OpenSim::TimestampGreaterThanEqualToNext::TimestampGreaterThanEqualToNext()</a>, <a class="el" href="classOpenSim_1_1TimestampLessThanEqualToPrevious.html#a3a979a3e0814cbfc7679042dff887270">OpenSim::TimestampLessThanEqualToPrevious::TimestampLessThanEqualToPrevious()</a>, <a class="el" href="classOpenSim_1_1UnexpectedColumnLabel.html#a68928669c3756bcc5f39960edac83f18">OpenSim::UnexpectedColumnLabel::UnexpectedColumnLabel()</a>, <a class="el" href="classOpenSim_1_1UnexpectedMetaDataKey.html#af1f4672a17519ec0e65e01a509fb54cd">OpenSim::UnexpectedMetaDataKey::UnexpectedMetaDataKey()</a>, and <a class="el" href="classOpenSim_1_1UnsupportedFileType.html#af09192a6eec58a2e0f1e2ef5f6140390">OpenSim::UnsupportedFileType::UnsupportedFileType()</a>.</p>

</div>
</div>
<a id="ae3a719b15a4f522207847a720e2af7b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae3a719b15a4f522207847a720e2af7b1">&#9670;&nbsp;</a></span>getMessage()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const char* OpenSim::Exception::getMessage </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="abe7156536aa1a7205ed74660ca72e7f5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abe7156536aa1a7205ed74660ca72e7f5">&#9670;&nbsp;</a></span>print()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void OpenSim::Exception::print </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>aOut</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a95f5578dc48c56f828986c346f13a8e0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a95f5578dc48c56f828986c346f13a8e0">&#9670;&nbsp;</a></span>setMessage()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::Exception::setMessage </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>aMsg</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ab82fe5f267ae6474eec07f805b9192ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab82fe5f267ae6474eec07f805b9192ca">&#9670;&nbsp;</a></span>what()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const char* OpenSim::Exception::what </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1TableReporter__.html#a8965717b79c4457df71f15c7ab5761b4">OpenSim::TableReporter_&lt; InputT, ValueT &gt;::implementReport()</a>.</p>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a22b9c2ec3cb629075f2d96a6669cdbc9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a22b9c2ec3cb629075f2d96a6669cdbc9">&#9670;&nbsp;</a></span>OPENSIM_THROW</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">#define OPENSIM_THROW</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">EXCEPTION, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>...</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;    throw EXCEPTION{__FILE__, __LINE__, __func__, __VA_ARGS__};</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p><br  />
 </p>

</div>
</div>
<a id="ae16eef2046486e4847244130a27ec6b8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae16eef2046486e4847244130a27ec6b8">&#9670;&nbsp;</a></span>OPENSIM_THROW_IF</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">#define OPENSIM_THROW_IF</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">CONDITION, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">EXCEPTION, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>...</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This macro checks the given condition and throws the given exception if the condition is true. </p>
<p>Here's an example that throws an exception if some result is incorrect, and passes <code>result</code> and <code>5</code> to the constructor of the <code>ResultIsIncorrect</code> exception: </p><div class="fragment"><div class="line"><span class="keyword">auto</span> result = getSomeResult();</div>
<div class="line"><a class="code" href="classOpenSim_1_1Exception.html#ae16eef2046486e4847244130a27ec6b8">OPENSIM_THROW_IF</a>(result != 5, ResultIsIncorrect, result, 5);</div>
<div class="ttc" id="aclassOpenSim_1_1Exception_html_ae16eef2046486e4847244130a27ec6b8"><div class="ttname"><a href="classOpenSim_1_1Exception.html#ae16eef2046486e4847244130a27ec6b8">OpenSim::Exception::OPENSIM_THROW_IF</a></div><div class="ttdeci">#define OPENSIM_THROW_IF(CONDITION, EXCEPTION,...)</div><div class="ttdoc">This macro checks the given condition and throws the given exception if the condition is true.</div><div class="ttdef"><b>Definition:</b> Exception.h:77</div></div>
</div><!-- fragment --><p> <br  />
 </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/Exception.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1Exception.html">Exception</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:21 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
